package com.xx.merchanthbh.data.http.requst;

import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.HomeStatisticalBean;
import com.xx.merchanthbh.data.http.respons.MessageBean;
import com.xx.merchanthbh.data.http.respons.UserInfoBean;
import com.xx.xxviewlibrary.model.VersionBean;
import com.xx.xxviewlibrary.model.VersionBody;

import java.util.Arrays;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;
import retrofit2.Response;

public class HomeRequest extends BaseRespons {
    /**
     * 登录
     */
    public Observable<BaseResponse<String>> login(String user,String pwd) {
        return getApiService().Login(
                new ApiParams<LoginRequestBody>().setParams(
                        new LoginRequestBody(user,pwd,"02")
                )
        );
    }

    /**
     * 登陆入参
     * userType : 10 系统用户，01 企业用户，02商户用户，13消费者用户
     */
    public class LoginRequestBody{
        String phone;
        String password;
        String userType;

        public LoginRequestBody(String phone, String password, String userType) {
            this.phone = phone;
            this.password = password;
            this.userType = userType;
        }

        public String getPhone() {
            return phone;
        }

        public void setPhone(String phone) {
            this.phone = phone;
        }

        public String getPassword() {
            return password;
        }

        public void setPassword(String password) {
            this.password = password;
        }

        public String getUserType() {
            return userType;
        }

        public void setUserType(String userType) {
            this.userType = userType;
        }
    }
    /**
     * 获取用户信息
     */
    public Observable<BaseResponse<UserInfoBean>> getUserInfo() {
        return getApiService().getUserInfo();
    }
    /**
     * 获取订单信息
     */
    public Observable<BaseResponse<HomeStatisticalBean>> getHomeStatistical() {
        return getApiService().getHomeStatistical();
    }

    /**
     * 强制更新
     */
    public Observable<BaseResponse<VersionBean>> checkVersion() {
        return getApiService().getLineVersion(
                new ApiParams<VersionBody>().setParams(
                        new VersionBody("2", "2")
                )
        );
    }

    /**
     * 签到
     */
    public Observable<BaseResponse<Boolean>> getSign(String id) {
        return getApiService().getSign(id);
    }

    /** * 获取消息列表 */
    public Observable<BasePageResponse<MessageBean>> getMessageList(String flag,Integer page) {
        return getApiService().getMessageList(flag,page);
    }
    /**
     * 隐私政策
     * */
    public Observable<BaseResponse<List<String>>> getProtocols() {
        // 假设ApiParams和ApiService已经被正确设置和实现
        return getApiService().getProtocols(new ApiParams<>().setParams(Arrays.asList("6","7","13","9","10")));
    }
}
